Cdio447/Models/payment_gateways.cs
namespace Cdio447.Models
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel.DataAnnotations;
    using System.ComponentModel.DataAnnotations.Schema;
    using System.Data.Entity.Spatial;

    public partial class payment_gateways
    {
        [Key]
        [DatabaseGenerated(DatabaseGeneratedOption.None)]
        public int user_id { get; set; }

        public int bank_id { get; set; }

        public string account_name { get; set; }

        public string account_code { get; set; }

        public virtual banks banks { get; set; }

        public virtual users users { get; set; }
    }
}

Cdio447/ViewModels/PaymentGateway.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ComponentModel.DataAnnotations;

namespace Cdio447.ViewModels
{
    public class PaymentGateway
    {
        public int user_id { get; set; }

        public int bank_id { get; set; }

        public string account_name { get; set; }

        public string account_code { get; set; }
    }
}

Cdio447/Controllers/WithdrawlController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Cdio447.Models;
using Cdio447.Code;
using Cdio447.ViewModels;

namespace Cdio447.Controllers
{
    public class WithdrawlController : Controller
    {
        private DBContext db = new DBContext();
        // GET: Withdrawl
        public ActionResult PaymentGateway()
        {
            var session = (UserSession)Session[CommonConstants.USER_SESSION];
            if (session != null)
            {
                var banks = db.banks.ToList();
                ViewBag.banks = banks;
                ViewBag.success = null;
                ViewBag.CheckModel = "";
                var model = db.payment_gateways.Find(session.User_id);
                if(model == null)
                {
                    ViewBag.CheckModel = null;
                }
                return View(model);
            }
            return RedirectToAction("Login", "Login");
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult PaymentGateway(payment_gateways pw)
        {
            var banks = db.banks.ToList();
            ViewBag.banks = banks;
            var session = (UserSession)Session[CommonConstants.USER_SESSION];
            if (session != null)
            {
                pw.user_id = session.User_id;
                if (ModelState.IsValid)
                {
                    if(pw.bank_id == 0)
                    {
                        ModelState.AddModelError("bank_id", "Vui lòng chọn cổng thanh toán");
                    } else
                    {
                        payment_gateways getPW = db.payment_gateways.SingleOrDefault(x => x.user_id == session.User_id);
                        if (getPW == null)
                        {
                            db.payment_gateways.Add(pw);
                            db.SaveChanges();
                            ViewBag.success = "";
                        }
                        else
                        {
                            getPW.bank_id = pw.bank_id;
                            getPW.account_code = pw.account_code;
                            getPW.account_name = pw.account_name;
                            ViewBag.success = "";
                            db.SaveChanges();
                        }
                    }
                }
                return View(pw);
            }
            return RedirectToAction("Login", "Login");
        }
        [HttpGet]
        public ActionResult Withdrawl()
        {
            var session = (UserSession)Session[CommonConstants.USER_SESSION];
            if (session != null)
            {
                var pwModel = db.payment_gateways.SingleOrDefault(x => x.user_id == session.User_id);
                ViewBag.pwModel = pwModel;
                var getWH = db.withdrawl_histories.Where(x => x.user_id == session.User_id).ToList();
                ViewBag.CheckModel = "";
                ViewBag.CheckHistory = null;
                ViewBag.amountAble = getAmountAble();
                if (pwModel == null)
                    ViewBag.CheckModel = null;
                if (getWH != null)
                    ViewBag.CheckHistory = getWH;
                return View();
            }
            return RedirectToAction("Login", "Login");
        }

        [HttpPost]
        public ActionResult Withdrawl(WidthdrawlViewModel wd)
        {
            
            var session = (UserSession)Session[CommonConstants.USER_SESSION];
            if (session != null)
            {
                var pwModel = db.payment_gateways.SingleOrDefault(x => x.user_id == session.User_id);
                ViewBag.pwModel = pwModel;
                var getWH = db.withdrawl_histories.Where(x => x.user_id == session.User_id).ToList();
                ViewBag.CheckModel = "";
                ViewBag.CheckHistory = null;
                ViewBag.amountAble = getAmountAble();
                decimal currentMoney = (decimal)pwModel.users.current_money;
                if (pwModel == null)
                    ViewBag.CheckModel = null;
                if (getWH != null)
                    ViewBag.CheckHistory = getWH;
                if (ModelState.IsValid)
                {
                    decimal convert = decimal.Parse(wd.amount);
                    if ((convert % 50000) != 0)
                    {
                        ModelState.AddModelError("amount", "Số tiền rút phải là bội số của 50,000");
                    } else if(convert <= 250000)
                    {
                        ModelState.AddModelError("amount", "Số tiền rút phải lớn hơn hoặc bằng 250,000 VND");
                    } else if (convert > currentMoney)
                    {
                        ModelState.AddModelError("amount", "Số tiền rút phải nhỏ hơn số tiền hiện có");
                    } else
                    {
                        withdrawl_histories newWd = new withdrawl_histories();
                        string datetime = DateTime.Now.ToString("dd/MM/yyyy HH:mm:ss");
                        DateTime date = DateTime.ParseExact(datetime, "dd/MM/yyyy HH:mm:ss", null);
                        newWd.user_id = session.User_id;
                        newWd.total = convert;
                        newWd.status = 1;//dang xu ly
                        newWd.created_at = date;
                        db.withdrawl_histories.Add(newWd);
                        users user = db.users.Find(session.User_id);
                        user.current_money = user.current_money - convert;
                        db.SaveChanges();
                        ViewBag.success = "";
                    }
                }
                return View(wd);
            }
            return RedirectToAction("Login", "Login");
        }

        public decimal getAmountAble()
        {
            var session = (UserSession)Session[CommonConstants.USER_SESSION];
            var pwModel = db.users.SingleOrDefault(x => x.id == session.User_id);
            decimal currentMoney = (decimal)pwModel.current_money;
            decimal amountAble = 0;
            if (currentMoney >= 250000)
            {
                amountAble = currentMoney - 50000;
            }
            return amountAble;
        }
    }
}

Cdio447/Views/Withdrawl/PaymentGateway.cshtml
@{
    ViewBag.Title = "PaymentGateway";
    var banks = (List<Cdio447.Models.banks>)ViewBag.banks;
    var checkModel = ViewBag.CheckModel;
    var success = ViewBag.success;
}
@model Cdio447.Models.payment_gateways
<div class="row justify-content-center">
    <div class="col-12 col-lg-7">
        <div class="form-payin my-2 my-lg-4 p-3">
            @using (Html.BeginForm("PaymentGateway", "Withdrawl", FormMethod.Post))
            {
                <h3 class="text-center mb-0 pb-3">Đăng ký cổng thanh toán</h3>
                @Html.AntiForgeryToken()
                if (checkModel == null)
                {
                    <div class="form-group mb-2 list-bank">
                        <label>Cổng thanh toán</label>
                        <select id="select_bankId" class="form-control">
                            <option value="0">Chọn Cổng thanh toán</option>
                            @foreach (var bank in banks)
                            {
                                <option value="@bank.id">@bank.name</option>
                            }
                        </select>
                        @Html.HiddenFor(model => model.bank_id, new { @id = "bankIDPW" })
                        @Html.ValidationMessageFor(model => model.bank_id, "", new { @class = "text-danger mt-1" })
                    </div>
                }
                else
                {
                    <div class="form-group mb-2 list-bank">
                        <label>Cổng thanh toán</label>
                        <select id="select_bankId" class="form-control">
                            <option value="0">Chọn Cổng thanh toán</option>
                            @foreach (var bank in banks)
                            {
                                <option value="@bank.id" @if (Model.bank_id == bank.id) { <text> selected="selected" </text> }>@bank.name</option>
                            }
                        </select>
                        @Html.HiddenFor(model => model.bank_id, new { @id = "bankIDPW" })
                        @Html.ValidationMessageFor(model => model.bank_id, "", new { @class = "text-danger" })
                    </div>
                }
                <div class="form-row">
                    <div class="form-group col-md-6">
                        <label for="inputEmail4">Chủ tài khoản</label>
                        @Html.TextBoxFor(model => model.account_name, new { @class = "form-control", @autofocus = "autofocus" })
                        @Html.ValidationMessageFor(model => model.account_name, "", new { @class = "text-danger mt-1" })
                    </div>
                    <div class="form-group col-md-6">
                        <label for="inputPassword4">Số tài khoản</label>
                        @Html.TextBoxFor(model => model.account_code, new { @class = "form-control", @autofocus = "autofocus" })
                        @Html.ValidationMessageFor(model => model.account_code, "", new { @class = "text-danger mt-1" })
                    </div>
                </div>
                <div class="form-group">
                    <p>Tiến hành rút tiền<a href="@Url.Action("Withdrawl","Withdrawl")"> tại đây</a></p>
                </div>
                <div class="form-group">
                    <p><b>Lưu ý: </b><span class="text-danger">Vui lòng cung cấp số tài khoản và chủ tài khoản thật để thực hiện giao dịch rút tiền</span></p>
                </div>
                <div class="form-group mb-0 text-center pt-3" style="border-top: 1px solid #e74c3c">
                    <button type="submit" class="btn btn_template">Đăng ký</button>
                </div>
            }
        </div>
    </div>
</div>
@section scripts {
    <script>
        $('input[type=text][name=account_name]').on('change keyup', function () {
            var getText = $(this).val();
            getText = getText.toUpperCase();
            $(this).val(getText);
        });
    </script>
    @if (success != null)
    {
        <script>
            setTimeout(function () { alert("Đăng ký thành công"); }, 100);
        </script>
    }
}

Cdio447/Views/Withdrawl/Withdrawl.cshtml
@{
    ViewBag.Title = "PaymentGateway";
    var checkModel = ViewBag.CheckModel;
    var checkHistory = (List<Cdio447.Models.withdrawl_histories>)ViewBag.CheckHistory;
    var pwModel = (Cdio447.Models.payment_gateways)ViewBag.pwModel;
    var success = ViewBag.success;
    decimal amountAble = ViewBag.amountAble;
}
@using Cdio447.Supports;
@model Cdio447.ViewModels.WidthdrawlViewModel
@section styles {
    <style>
        .validation-summary-errors ul {
            padding: .75rem;
            margin: 0
        }
    </style>
}
<div class="row justify-content-center">
    <div class="col-12 col-lg-7">
        <div class="form-payin my-2 my-lg-4 p-3" style="padding-bottom: 0px !important">
            @using (Html.BeginForm("Withdrawl", "Withdrawl", FormMethod.Post))
            {
                @Html.AntiForgeryToken()
                <h3 class="text-center mb-0 pb-3">Rút tiền</h3>
                <table class="table">
                    <tbody>
                        @if (pwModel == null)
                        {
                            <tr>
                                <td style="border-top: 0px" colspan="2" class="text-danger">Bạn cần đăng ký cổng thanh toán trước khi giao dịch <a href="@Url.Action("PaymentGateway", "Withdrawl")">tại đây</a></td>
                            </tr>
                            <tr>
                                <td class="text-left">Cổng thanh toán</td>
                                <td class="text-danger text-left">Chưa đăng ký</td>
                            </tr>
                            <tr>
                                <td class="text-left">Chủ tài khoản</td>
                                <td class="text-danger text-left">Chưa đăng ký</td>
                            </tr>
                            <tr>
                                <td class="text-left">Số tài khoản</td>
                                <td class="text-danger text-left">Chưa đăng ký</td>
                            </tr>
                        }
                        else
                        {
                            <tr>
                                <td style="border-top: 0px" class="text-left">Cổng thanh toán</td>
                                <td style="border-top: 0px" class="text-left">Ngân hàng @pwModel.banks.name</td>
                            </tr>
                            <tr>
                                <td class="text-left">Chủ tài khoản</td>
                                <td class="text-left">@pwModel.account_name</td>
                            </tr>
                            <tr>
                                <td class="text-left">Số tài khoản</td>
                                <td class="text-left">@pwModel.account_code</td>
                            </tr>
                            <tr>
                                <td class="text-left">Số tiền có thể rút</td>
                                <td class="text-left">@FunctionSupport.convertVND((decimal)amountAble, " VND")</td>
                            </tr>
                            <tr>
                                <td class="text-left">Bạn muốn rút</td>
                                <td class="text-left">
                                    <input type="text" id="amount_convert" class="form-control" />
                                    @Html.HiddenFor(model => model.amount, new { @class = "form-control", @id = "amountPayWd" })
                                    @Html.ValidationMessageFor(model => model.amount, "", new { @class = "text-danger" })
                                </td>
                            </tr>
                            <tr>
                                <td colspan="2">Thay đổi cổng thanh toán tại đây <a href="@Url.Action("PaymentGateway", "Withdrawl")">tại đây</a></td>
                            </tr>
                            <tr>
                                <td colspan="2"><b>Lưu ý: </b><span class="text-danger">Số tiền hiện tại trong tài khoản phải lớn hơn 250,000đ là điều kiện để thực hiện giao dịch</span></td>
                            </tr>
                            <tr>
                                <td style="border-top: 1px solid #e74c3c"></td>
                                <td style="border-top: 1px solid #e74c3c" class="text-left py-3">
                                    <button type="submit" class="btn btn_template">Rút tiền</button>
                                </td>
                            </tr>
                        }
                    </tbody>
                </table>
            }
        </div>
    </div>
    <div class="col-12">
        <div class="box-histories-withdrawl mt-3">
            <h4><i>LỊCH SỬ RÚT TIỀN</i></h4>
            <table class="table table-bordered table-hover">
                <thead>
                    <tr>
                        <th class="table-withdraw-th">Thời gian</th>
                        <th class="table-withdraw-th">Ngân hàng</th>
                        <th class="table-withdraw-th">Số tiền rút</th>
                        <th class="table-withdraw-th">Tình trạng</th>
                        <th class="table-withdraw-th">Chủ tài khoản</th>
                        <th class="table-withdraw-th">Số tài khoản</th>
                    </tr>
                </thead>
                @if (checkHistory != null)
                {
                <tbody>
                    @foreach (var his in checkHistory)
                    {
                    <tr>
                        <td>@FunctionSupport.convertDatetimeVN(his.created_at)</td>
                        <td>@his.users.payment_gateways.banks.name</td>
                        <td>@FunctionSupport.convertVND(his.total, " - VND")</td>
                        @if (his.status == 1) {
                        <td class="text-primary">Đang xử lý</td>
                        } else { <td class="text-success">Đã thanh toán</td> }
                        <td>@his.users.payment_gateways.account_name</td>
                        <td>@his.users.payment_gateways.account_code</td>
                    </tr>
                    }
                </tbody>
                }
                else
                {
                    <tbody>
                        <tr>
                            <td colspan="6" class="text-danger">Chưa có lịch sử rút tiền</td>
                        </tr>
                    </tbody>
                }
            </table>
        </div>
    </div>
</div>
@section scripts {
    @if (success != null)
    {
        <script>
            setTimeout(function () { alert("Rút tiền thành công, tiền sẽ được chuyển trong vài ngày tới"); }, 100);
            setTimeout(function () { window.location.href = "/"; }, 2000);
        </script>
    }
}